/*
 *	PUi̐l
 */
#include "mytypes.h"
#include "gpupkt.h"

#define FONTWIDTH	8
#define FONTHEIGHT	16

int InputHex(volatile uchar *padBuf, void *dest, int nNybble, ushort x, ushort y)
{
	int i;
	int c;
	int cursor;
	int counter;
	RECT rect;
	RGB24 bg = 0;
	RGB24 fg = MKRGB24(0xff, 0xff, 0xff);
	RGB24 b, f;
	int ret;
	unsigned char *buffer = (unsigned char *)dest;
	uchar oldBuf[4];
#define KEYWAIT	10
	int keyWait = KEYWAIT;
	
	memcpy(oldBuf, (uchar *)padBuf, sizeof (oldBuf));
	rect.x = x;
	rect.y = y;
	rect.w = FONTWIDTH * nNybble;
	rect.h = FONTHEIGHT;
	FillRect(&rect, bg);
	GPU_sync();
	
	cursor = 0;
	counter = 0;
	for (;;) {
		memcpy(oldBuf, (uchar *)padBuf, sizeof (oldBuf));
		if (++ counter > 80) counter = 0;
		GPU_sync();
		bogoVSyncWait2(padBuf, 1);
		/*
		 *	ׂĕ`悵܂B
		 */
		for (i = 0 ; i < nNybble ; i ++) {
			c = buffer[i >> 1];
			if ((i & 1) == 0) c >>= 4;
			c &= 0x0f;
			if (c < 10) c += '0';
			else c += 'A' - 10;

			if (i == cursor && counter < 40) { f = bg; b = fg; }
			else { f = fg; b = bg; }
			KanaPutc(c, MKSHORT_YX(y, x + FONTWIDTH * i), f, b);
		}
		i = cursor >> 1;
		c = buffer[i];
		if ((cursor & 1) == 0) c >>= 4;
		c &= 0x0f;


		if (PADIS_CIRCLE(padBuf) && !PADIS_CIRCLE(oldBuf)) {			/*  */
			ret = 0;
			break;
		} else if (PADIS_CROSS(padBuf) && !PADIS_CROSS(oldBuf)) {			/* w */
			ret = -1;
			break;
		} else if (PADIS_LEFT(padBuf)) {	/*  */
			if (!PADIS_LEFT(oldBuf)) keyWait = 0;
			if (keyWait == 0) {
				keyWait = KEYWAIT;
				counter = 0;
				if (cursor != 0) cursor --;
			}
			keyWait --;
			continue;
		} else if (PADIS_RIGHT(padBuf)) {	/* E */
			if (!PADIS_RIGHT(oldBuf)) keyWait = 0;
			if (keyWait == 0) {
				keyWait = KEYWAIT;
				counter = 0;
				if (cursor + 1 < nNybble) cursor ++;
			}
			keyWait --;
			continue;
		} else if (PADIS_UP(padBuf)) {		/*  P */
			if (!PADIS_UP(oldBuf)) keyWait = 0;
			if (keyWait == 0) {
				keyWait = KEYWAIT;
				counter = 0;
				c ++;
			}
			keyWait --;
		} else if (PADIS_DOWN(padBuf)) {	/*  P */
			if (!PADIS_DOWN(oldBuf)) keyWait = 0;
			if (keyWait == 0) {
				keyWait = KEYWAIT;
				counter = 0;
				c --;
			}
			keyWait --;
		} else if (PADIS_TRIANGLE(padBuf)) {			/*  */
			c = 0;	/* [ɂB */
		} else {
			keyWait = KEYWAIT;
			if (PADIS_L1(padBuf) && !PADIS_L1(oldBuf)) {		/* L1 1000 XOR */
				counter = 0;
				c ^= 0x08;
			}
			if (PADIS_L2(padBuf) && !PADIS_L2(oldBuf)) {		/* L2 0100 XOR */
				counter = 0;
				c ^= 0x04;
			}
			if (PADIS_R1(padBuf) && !PADIS_R1(oldBuf)) {		/* R1 0010 XOR */
				counter = 0;
				c ^= 0x02;
			}
			if (PADIS_R2(padBuf) && !PADIS_R2(oldBuf)) {		/* R2 0001 XOR */
				counter = 0;
				c ^= 0x01;
			}
		}
		c &= 0x0f;
		if (cursor & 1) {
			buffer[i] &= 0xf0;
			buffer[i] |= c;
		} else {
			buffer[i] &= 0x0f;
			buffer[i] |= c << 4;
		}
	}
	FillRect(&rect, bg);

	return ret;
}


unsigned long ReverseEndian_4(void *p)
{
	unsigned char *ptr = (unsigned char *)p;
	unsigned char c;
	
	c = ptr[0];
	ptr[0] = ptr[3];
	ptr[3] = c;
	c = ptr[1];
	ptr[1] = ptr[2];
	ptr[2] = c;
	
	return *(unsigned long *)p;
}

unsigned short ReverseEndian_2(void *p)
{
	unsigned char *ptr = (unsigned char *)p;
	unsigned char c;
	
	c = ptr[0];
	ptr[0] = ptr[1];
	ptr[1] = c;
	
	return *(unsigned short *)p;
}
