/*
 *	jFŗD
 *	APSX  sprintf Ȃ̂ŁAgȂB
 */
#include "r3000dis.h"

#define OP_SPECIAL	0
#define OP_REGIMM	1

#ifndef NULL
#define NULL	( (void *) 0 )
#endif

#define TABSTOP	8	/* 10 ȏ */

static char const * const R_SpecialMnemonics[64] = {
	"sll", NULL, "srl", "sra",
	"sllv", NULL, "srlv", "srav",
	"jr", "jalr", NULL, NULL,
	"syscall", "break", NULL, NULL,

	"mfhi", "mthi", "mflo", "mtlo",
	NULL, NULL, NULL, NULL,
	"mult", "multu", "div", "divu",
	NULL, NULL, NULL, NULL,

	"add", "addu", "sub", "subu",
	"and", "or", "xor", "nor",
	NULL, NULL, "slt", "sltu",
	NULL, NULL, NULL, NULL,

	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL
};

static char const * const I_Mnemonics[64] = {
	NULL, NULL, "j", "jal",
	"beq", "bne", "blez", "bgtz",
	"addi", "addiu", "slti", "sltiu",
	"andi", "ori", "xori", "lui",

	"cop0", "cop1", "cop2", "cop3",
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL,

	"lb", "lh", "lwl", "lw",
	"lbu", "lhu", "lwr", NULL,
	"sb", "sh", "swl", "sw",
	NULL, NULL, "swr", NULL,

	"lwc0", "lwc1", "lwc2", "lwc3",
	NULL, NULL, NULL, NULL,
	"swc0", "swc1", "swc2", "swc3",
	NULL, NULL, NULL, NULL
};

const char RegisterString[32][3]={
	"$0", "at", "v0", "v1",
	"a0", "a1", "a2", "a3",
	"t0", "t1", "t2", "t3",
	"t4", "t5", "t6", "t7",
	"s0", "s1", "s2", "s3",
	"s4", "s5", "s6", "s7",
	"t8", "t9", "k0", "k1",
	"gp", "sp", "fp", "ra"
};


static int doSpecial(unsigned long addr, unsigned long code, char *buffer);
static int doRegmm(unsigned long addr, unsigned long code, char *buffer);
static int doNormal(unsigned long addr, unsigned long code, char *buffer);

int R3000dis(unsigned long addr, unsigned long code, char *buffer)
{
	register int v0;
	
	int op = (code >> 26) & 0x3f;

	mkLongHex(buffer, addr);
	buffer[8] = ':';
	buffer += 9;
	mkLongHex(buffer, code);
	buffer[8] = ' ';
	buffer = buffer + 9;

	if (op == OP_SPECIAL) v0 = doSpecial(addr, code, buffer);
	else if (op == OP_REGIMM) v0 = doRegmm(addr, code, buffer);
	else v0 = doNormal(addr, code, buffer);

	if (v0 < 0) buffer[0] = '\0';
	return v0;
}


static int doSpecial(unsigned long addr, unsigned long code, char *buffer)
{
	const int funct = code & 0x3f;
	int tmp;
	int i;
	const char *ptr;
	int rs, rt, rd;


	ptr = R_SpecialMnemonics[funct];
	if (ptr == NULL) return -1;

	rs = (code >> (6 + 5 + 5 + 5)) & 0x1f;
	rt = (code >> (6 + 5 + 5)) & 0x1f;
	rd = (code >> (6 + 5)) & 0x1f;


	memset(buffer, ' ',TABSTOP * 4);
/*	buffer[TABSTOP * 4] = '\0'; */

	/* MNEMONIC */
	for (i = 0 ; *ptr != '\0' ; i ++) buffer[i] = *ptr ++;

	i = TABSTOP;
	tmp = funct >> 2;
	if (funct & 0x20) {
		/* op	rd, rs, rt */
		ptr = RegisterString[rd];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = ',';
		i += 3;

		ptr = RegisterString[rs];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = ',';
		i += 3;

		ptr = RegisterString[rt];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = '\0';
	} else if (tmp == 1) {
	 	/* op	rd, rt, rs */
		ptr = RegisterString[rd];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = ',';
		i += 3;

		ptr = RegisterString[rt];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = ',';
		i += 3;

		ptr = RegisterString[rs];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = '\0';

	} else if (tmp == 2) {		/* JR, JALR */
		ptr = RegisterString[rs];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = '\0';
#if 0
	 	/* op	in */
		tmp = code & 0x03ffffff;
		tmp <<= 2;
		tmp |= (addr + 4) & 0xf0000000;
		buffer[i] = '$';
		mkLongHex(&buffer[i + 1], tmp);
		buffer[i + 1 + 8] = '\0';
#endif
	} else if (tmp == 0) {		/* SLL, SRL, SRA (NOP) */
	 	/* op	rd, rt, sa */
		ptr = RegisterString[rd];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = ',';
		i += 3;

		ptr = RegisterString[rt];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = ',';
		i += 3;

		tmp = (code >> 6) & 0x1f;
		if (tmp >= 10) {
			buffer[i] = '0' + (tmp / 10);
			buffer[i + 1] = '0' + (tmp % 10);
			buffer[i + 2] = '\0';
		} else {
			buffer[i] = '0' + tmp;
			buffer[i + 1] = '\0';
		}

		if (code == 0) {
			buffer[0] = 'n';
			buffer[1] = 'o';
			buffer[2] = 'p';
			buffer[3] = '\0';
		}
	} else if (tmp == 6) {		/* MULT, DIV */
	 	/* op	rs, rt */
		ptr = RegisterString[rs];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = ',';
		i += 3;

		ptr = RegisterString[rt];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = '\0';
	} else if (tmp == 3) {		/* SYSCALL, BREAK */
	 	/* op code(20bit) */
		tmp = code & 0x03ffffff;
		buffer[i] = '$';
		mkLongHex(&buffer[i + 1], tmp);
		buffer[i + 1 + 8] = '\0';
	} else if (!(funct & 1)) {	/* MFHI, MFLO */
	 	/* op	rd */
		ptr = RegisterString[rd];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = '\0';
	} else {			/* MTHI, MTLO */
	 	/* op	rs */
		ptr = RegisterString[rs];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = '\0';
	}

	/*
	 *	funct:	command
	 *	-----------------
	 *
	 ****	op	rd, rs, rt
	 *	100000	ADD
	 *	100001	ADDU
	 *	100010	SUB
	 *	100011	SUBU
	 *
	 *	100100	AND
	 *	100101	OR
	 *	100110	XOR
	 *	100111	NOR
	 *
	 *	101010	SLT
	 *	101011	SLTU
	 *
	 ***		rd, rt, rs
	 *	000100	SLLV
	 *	000110	SRLV
	 *	000111	SRAV
	 *
	 ****	op	in
	 *	001000	JR
	 *	001001	JALR
	 *
	 ****	op	rd, rt, sa
	 *	000000	SLL	(nop)
	 *	000010	SRL
	 *	000011	SRA
	 *
	 ****	op	rs, rt
	 *	011000	MULT
	 *	011001	MULTU
	 *	011010	DIV
	 *	011011	DIVU
	 *
	 ****	op code(20bit)
	 *	001100	SYSCALL
	 *	001101	BREAK
	 *
	 ****	op	rd
	 *	010000	MFHI
	 *	010010	MFLO
	 *
	 ****	op	rs
	 *	010001	MTHI
	 *	010011	MTLO
	 *
	 */

	return 0;
}

static int doRegmm(unsigned long addr, unsigned long code, char *buffer)
{
	const int funct = (code >> 16) & 0x1f;	/* rt */
	int rs = (code >> 21) & 0x1f;
	short imm = (code & 0xffff) << 2;
	unsigned long offset;
	int tmp = funct >> 1;
	int i;
	const char *ptr;


	if (tmp != 0 && tmp != 0x80) return -1;

	memset(buffer, ' ', TABSTOP);

	/* MNEMONIC */
	buffer[0] = 'b';
	if (funct & 1) {
		buffer[1] = 'g';
		buffer[2] = 'e';
	} else {
		buffer[1] = 'l';
		buffer[2] = 't';
	}
	buffer[3] = 'z';
	if (funct & 0x10) {
		buffer[4] = 'a';
		buffer[5] = 'l';
	}

	i = TABSTOP;
	ptr = RegisterString[rs];
	buffer[i] = ptr[0];
	buffer[i + 1] = ptr[1];
	buffer[i + 2] = ',';
	i += 3;

	offset = ((long)addr + 4 + imm);

	buffer[i] = '$';
	mkLongHex(&buffer[i + 1], offset);
	buffer[i + 1 + 8] = '\0';

	/*
	 *
	 *	00000	BLTZ
	 *	00001	BGEZ
	 *	10000	BLTZAL
	 *	10001	BGEZAL
	 *
	 */

	return 0;
}

static int doNormal(unsigned long addr, unsigned long code, char *buffer)
{
	const int funct = (code >> 26) & 0x3f;
	int tmp;
	int i;
	const char *ptr;
	int rs, rt, rd;
	short imm;

	ptr = I_Mnemonics[funct];
	if (ptr == NULL) return -1;

	rs = (code >> (6 + 5 + 5 + 5)) & 0x1f;
	rt = (code >> (6 + 5 + 5)) & 0x1f;
	rd = (code >> (6 + 5)) & 0x1f;
	imm = code & 0xffff;

	memset(buffer, ' ',TABSTOP * 4);
/*	buffer[TABSTOP * 4] = '\0'; */

	/* MNEMONIC */
	for (i = 0 ; *ptr != '\0' ; i ++) buffer[i] = *ptr ++;

	i = TABSTOP;

	if (funct & 0x20) {
		/* op	rt, of(base) */
		ptr = RegisterString[rt];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = ',';
		i += 3;

		buffer[i] = '$';

		mkShortHex(&buffer[i + 1], code & 0xffff);

		ptr = RegisterString[rs];
		buffer[i + 5] = '(';
		buffer[i + 6] = ptr[0];
		buffer[i + 7] = ptr[1];
		buffer[i + 8] = ')';
		buffer[i + 9] = '\0';
	} else if (funct == 15) {	/* LUI */
	 	/* op	rt, im */
		ptr = RegisterString[rt];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = ',';
		i += 3;

		buffer[i] = '$';
		mkShortHex(&buffer[i + 1], imm);
		buffer[i + 5] = '\0';
	} else if ((funct >> 3) == 1) {
	 	/* op	rt, rs, im */
		ptr = RegisterString[rt];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = ',';
		i += 3;

		ptr = RegisterString[rs];
		buffer[i] = ptr[0];
		buffer[i + 1] = ptr[1];
		buffer[i + 2] = ',';
		i += 3;

		buffer[i] = '$';
		mkShortHex(&buffer[i + 1], imm);
		buffer[i + 5] = '\0';
	} else if ((funct >> 2) == 4) {	/* COPz */
		int type = 0;
		switch (rs) {
		case 0: /* MFCz */
			type = 1;
			buffer[0] = 'm';
			buffer[1] = 'f';
			buffer[2] = 'c';
/*			buffer[3] = XĂ */
			break;
		case 4:	/* MTCz */
			type = 1;
			buffer[0] = 'm';
			buffer[1] = 't';
			buffer[2] = 'c';
/*			buffer[3] = XĂ */
			break;
		case 2:	/* CFCz */
			type = 1;
			buffer[0] = 'c';
			buffer[1] = 'f';
			buffer[2] = 'c';
/*			buffer[3] = XĂ */
			break;
		case 6: /* CTCz */
			type = 1;
			buffer[0] = 'c';
			buffer[1] = 't';
			buffer[2] = 'c';
/*			buffer[3] = XĂ */
			break;
		case 8:	/* THRU... */
		case 12:/* BCzF/BCzT ߂ǂ̂Ŗ */
		/*	break; */
		default:/* COPz */
			break;
		}
		if (type == 0) {
			buffer[i] = '$';
			mkLongHex(&buffer[i + 1], code & 0x03ffffff);
			buffer[i + 1 + 8] = '\0';
		} else {
			ptr = RegisterString[rt];
			buffer[i] = ptr[0];
			buffer[i + 1] = ptr[1];
			buffer[i + 2] = ',';
			i += 3;
			buffer[i ++] = '$';
			if (rd >= 10) {
				buffer[i ++] = rd / 10 + '0';
			}
			buffer[i ++] = rd % 10 + '0';
			buffer[i] = '\0';
		}
	} else {
		imm <<= 2;
		tmp = (funct >> 1) & 3;
		if (tmp == 1) {		/* J, JAL */
	 		/* op	in */
			tmp = code & 0x03ffffff;
			tmp <<= 2;
			tmp |= (addr + 4) & 0xf0000000;
			buffer[i] = '$';
			mkLongHex(&buffer[i + 1], tmp);
			buffer[i + 1 + 8] = '\0';
		} else if (tmp == 2) {	/* BEQ, BNE */
	 		/* op	rs, rt, of */
			ptr = RegisterString[rs];
			buffer[i] = ptr[0];
			buffer[i + 1] = ptr[1];
			buffer[i + 2] = ',';
			i += 3;

			ptr = RegisterString[rt];
			buffer[i] = ptr[0];
			buffer[i + 1] = ptr[1];
			buffer[i + 2] = ',';
			i += 3;

			buffer[i] = '$';
			mkLongHex(&buffer[i + 1], ((long)addr + 4 + imm));
			buffer[i + 1 + 8] = '\0';

		} else {		/* BLEZ, BGTZ */
	 		/* op	rs, of */
			ptr = RegisterString[rs];
			buffer[i] = ptr[0];
			buffer[i + 1] = ptr[1];
			buffer[i + 2] = ',';
			i += 3;

			buffer[i] = '$';
			mkLongHex(&buffer[i + 1], ((long)addr + 4 + imm));
			buffer[i + 1 + 8] = '\0';
		}
	}
	
	/*
	 ****	op	base, rt, of
	 *	100000	LB
	 *	100001	LH
	 *	100010	LWL
	 *	100011	LW
	 *	100100	LBU
	 *	100101	LHU
	 *	100110	LWR
	 *	101000	SB
	 *	101001	SH
	 *	101010	SWL
	 *	101011	SW
	 *	101110	SWR
	 *	110001	LWC1
	 *	110010	LWC2
	 *	110011	LWC3
	 *	111001	SWC1
	 *	111010	SWC2
	 *	111011	SWC3
	 *
	 ****	op	rt, im
	 *	001111	LUI
	 *
	 ****	op	rt, rs, im
	 *	001000	ADDI
	 *	001001	ADDIU
	 *	001010	SLTI
	 *	001011	SLTIU
	 *	001100	ANDI
	 *	001101	ORI
	 *	001110	XORI
	 *
	 ****	op	in
	 *	000010	J
	 *	000011	JAL
	 *
	 ****	op	rs, rt, of
	 *	000100	BEQ
	 *	000101	BNE
	 *
	 ****	op	rs, of
	 *	000110	BLEZ
	 *	000111	BGTZ
	 *
	 ****	op	26bit/ op rt, rd
	 *	010000	COP0/MFC0/MTC0/CFC0/CTC0
	 *	010001	COP1/MFC1/MTC1/CFC1/CTC1
	 *	010010	COP2/MFC2/MTC2/CFC2/CTC2
	 *	010011	COP3/MFC3/MTC3/CFC3/CTC3
	 */

	return 0;
}


char *mkShortHex(char *buf, unsigned short s)
{
	int i;
	int c;

	for (i = 3 ; i >= 0 ; i --) {
		c = s & 0xf;
		s >>= 4;

		if (c >= 10) c = c - 10 + 'a';
		else c = c + '0';
		buf[i] = c;
	}

	return buf;
}

char *mkLongHex(char *buf, unsigned long l)
{
	mkShortHex(buf, l >> 16);
	mkShortHex(&buf[4], l & 0xffff);

	return buf;
}


#ifdef TEST
#include <stdio.h>

int main(int argc, char **argv)
{
	FILE *fp;
	unsigned long addr;
	unsigned long code;
	int c;
	char buf[256];

	if (argc == 1) {
		fprintf(stderr, "Usage: %s <ps-x exe>\n", argv[0]);
		return 1;
	}
	fp = fopen(argv[1], "rb");
	if (fp == NULL) {
		fprintf(stderr, "Cannot open file %s\n", argv[1]);
		return 1;
	}
	fseek(fp, 0x18, SEEK_SET);
	addr = fgetc(fp);
	addr |= fgetc(fp) << 8;
	addr |= fgetc(fp) << 16;
	addr |= fgetc(fp) << 24;
	fseek(fp, 0x800, SEEK_SET);

	for (;;addr += 4) {
		if ((c = fgetc(fp)) == EOF) break;
		code = c;
		if ((c = fgetc(fp)) == EOF) break;
		code |= c << 8;
		if ((c = fgetc(fp)) == EOF) break;
		code |= c << 16;
		if ((c = fgetc(fp)) == EOF) break;
		code |= c << 24;

		c = doit(addr, code, buf);
		printf("%08x:%08x\t", addr, code);
		if (c >= 0) fputs(buf, stdout);
		putchar('\n');
	}
	fclose(fp);
	return 0;
}

#endif
